Subject: bug#60660: closed (Re: bug#60660: Support git-formatted patches in diff-mode)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 10 Jan 2024 22:38:02 +0000

Your bug report

#60660: Support git-formatted patches in diff-mode

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
60660: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=60660
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#60660: Support git-formatted patches in diff-mode
From: Stefan Kangas <[email-masked]>
To: Juri Linkov <[email-masked]>
Cc: Eli Zaretskii <[email-masked]>, [email-masked]
Date: Wed, 10 Jan 2024 14:37:52 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Stefan Kangas <[email-masked]> writes:

> Juri Linkov <[email-masked]> writes:
>
>>>> This patch for emacs-29 fixes this bug, and the rest of fontification
>>>> could be implemented in master.
>>>
>>> OK for the emacs-29 branch
>>
>> Pushed to the emacs-29 branch.
>
> So is there more to do here, or should this bug be closed?  I'm not sure
> if it's still needed to track the below.
>
>>> (although I'm surprised that diff-beginning-of-hunk can return
>>> a position that is not before point).
>>
>> Indeed, strange to see this in 'diff-beginning-of-hunk':
>>
>>       (cond ...
>>         ((re-search-backward regexp nil t)) ; In the middle of a hunk.
>>         ((re-search-forward regexp nil t) ; At first hunk header.
>>                     =======
>>
>> Need to experiment more with this in master.

No further comments, so I'm closing this now.  Please reopen if it's
needed to track the above.

Subject: Support git-formatted patches in diff-mode
From: Juri Linkov <[email-masked]>
To: [email-masked]
Date: Sun, 08 Jan 2023 20:21:23 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Currently, there is a lot of misfontification in diff-mode visiting a git patch.
Two dashes in the signature separator are highlighted with the diff-removed face
(the existing diff-prev-line-if-patch-separator is used for something else).
Three dashes in the git patch header that separate a list of affected files
are highlighted with the diff-hunk-header face, etc.

But the worst case that raises an error is when an exclamation mark is used
at the beginning of the line in the git patch message.

This patch for emacs-29 fixes this bug, and the rest of fontification
could be implemented in master.

diff --git a/lisp/vc/diff-mode.el b/lisp/vc/diff-mode.el
index acfd2c30f0c..eb01dede56e 100644
--- a/lisp/vc/diff-mode.el
+++ b/lisp/vc/diff-mode.el
@@ -485,17 +485,19 @@ diff-font-lock-keywords
 	  ;; if below, use `diff-added'.
 	  (save-match-data
 	    (let ((limit (save-excursion (diff-beginning-of-hunk))))
-	      (if (save-excursion (re-search-backward diff-context-mid-hunk-header-re limit t))
-		  diff-indicator-added-face
-		diff-indicator-removed-face)))))
+              (when (< limit (point))
+                (if (save-excursion (re-search-backward diff-context-mid-hunk-header-re limit t))
+		    diff-indicator-added-face
+		  diff-indicator-removed-face))))))
      (2 (if diff-use-changed-face
 	    'diff-changed-unspecified
 	  ;; Otherwise, use the same method as above.
 	  (save-match-data
 	    (let ((limit (save-excursion (diff-beginning-of-hunk))))
-	      (if (save-excursion (re-search-backward diff-context-mid-hunk-header-re limit t))
-		  'diff-added
-		'diff-removed))))))
+	      (when (< limit (point))
+                (if (save-excursion (re-search-backward diff-context-mid-hunk-header-re limit t))
+		    'diff-added
+		  'diff-removed)))))))
     ("^\\(?:Index\\|revno\\): \\(.+\\).*\n"
      (0 'diff-header) (1 'diff-index prepend))
     ("^\\(?:index .*\\.\\.\\|diff \\).*\n" . 'diff-header)